# -*- coding:Utf-8 -*-
import os
import psyco
import es
import gamethread
import msglib
import langlib
import playerlib
psyco.full()

info = es.AddonInfo()
info.name = "redirectlib"
info.version = "1.2"
info.author = "EmbouT"
info.url = "http://forums.mattie.info/cs/forums/viewtopic.php?t=24215"
info.description = "Provided a class to redirect a player on another server"


# This script was inspired by that of SuperDave : http://forums.mattie.info/cs/forums/viewtopic.php?t=18588

### GLOBAL VARIABLE ###

# duration display redirection set by the server administrator (may be float)
default_delay = 15

default_kick = 1

lang = None

### CLASS ###

class Redirect(object):
    def __init__(self, ip, password=None, kick=None, delay=None):
        if not delay:
            delay = default_delay

        try:
            self.time = float(delay)

        except ValueError:
            es.dbgmsg(0, '[redirectlib] delay (%s) must be a number' % delay)
            es.dbgmsg(0, '[redirectlib] delay is set to default value : %s' % default_delay)
            self.time = float(default_delay)

        if not kick:
            kick = default_kick

        try:
            self.kick = int(kick)

        except ValueError:
            es.dbgmsg(0, '[redirectlib] kick (%s) must be 1 or 0' % kick)
            es.dbgmsg(0, '[redirectlib] kick is set to default value : %s' % default_kick)
            self.kick = default_kick

        if not password or password == '0':
            self.server = ip
        else :
            self.server = '%s;password %s' % (ip, password)


    def send(self, userid):
        if userid:
            if not es.exists('userid', userid):
                es.dbgmsg(0, '[redirectlib] %s is an invalid userid' % userid)
            else :
                msglib.VguiDialog(title=self.server, time=self.time, mode=msglib.VguiMode.ASKCONNECT).send(userid)
                if self.kick:
                    gamethread.delayedname(self.time, 'redirectlibkick%s' % userid, kickplayer, (self.server, userid))

def kickplayer(ip, userid):
    global lang
    es.server.queuecmd('kickid %s "%s"' % (userid, lang('kick', {'ip':ip}, playerlib.getPlayer(userid).get('lang'))))

def player_disconnect(event_var):
    gamethread.cancelDelayed('redirectlibkick%s' % event_var['userid'])

def loadlang():
    global lang
    path = es.getAddonPath('redirect') + '/redirect_languages.ini'
    if os.path.isfile(path):
        lang = langlib.Strings(path)
    else:
        es.dbgmsg(0, '[redirectlib] Unable to load redirect_languages.ini! Please ensure it is in the ../redirect/ directory.')
    if not lang:
        lang = nolang

def nolang(t, o, l):
    # if redirect_languages.ini is not found, set default message
    return "Please Try 'connect %s' in your console" % o['ip']

es.addons.registerForEvent(__import__(__name__), 'player_disconnect', player_disconnect)
loadlang()

